#ifndef _ANTIDOTEAPIOLE_H_
#define _ANTIDOTEAPIOLE_H_

// Constantes pour Antidote
// Antidote Constants
#define kNomClasseAntidote                                    _T("AntQ")
#define kCheminInstallationRegistreCle                        _T("SOFTWARE\\Druide informatique inc.\\Antidote")
#define kCheminInstallationRegistreValeur                     _T("DossierAntidote")
#define kValeurVersionAPI																			_T("VersionAPI")
#define kNomExecutableAntidote                                _T("Antidote.exe")
#define kParametreApiAntidote																	_T("-activex")
#define kProgIDAntidoteApiOle                                 _T("Antidote.ApiOle")
#define kChaineVersionAPI		                                 _T("2.0")

namespace CstApiAntidote
{
	// Correcteur
	// Corrector
	static const TCHAR* kOutilCorrecteur = _T("C");

	// Dernier dictionnaire appel
	// Last dictionary opened
	static const TCHAR* kDictionnaireDernierChoisi = _T("D");
	// Dictionnaire par dfaut
	// Default dictionary
	static const TCHAR* kDictionnaireDefaut = _T("D_Defaut");
	// Dictionnaire Dfinitions
	// Definitions dictionary
	static const TCHAR* kDictionnaireDefinitions = _T("D_Definitions");
	// Dictionnaire Synonymes
	// Synonyms dictionary
	static const TCHAR* kDictionnaireSynonymes = _T("D_Synonymes");
	// Dictionnaire Antonymes (module franais seulement)
	// Antonyms dictionary (French module only)
	static const TCHAR* kDictionnaireAntonymes = _T("D_Antonymes");
	// Dictionnaire Cooccurrences
	// Combinations dictionary
	static const TCHAR* kDictionnaireCooccurrences = _T("D_Cooccurrences");
	// Dictionnaire Champ lexical
	// Semantic Field dictionary
	static const TCHAR* kDictionnaireChampLexical = _T("D_ChampLexical");
	// Dictionnaire Conjugaison
	// Conjugation dictionary
	static const TCHAR* kDictionnaireConjugaison = _T("D_Conjugaison");
	// Dictionnaire Famille
	// Family dictionary
	static const TCHAR* kDictionnaireFamille = _T("D_Famille");
	// Dictionnaire Citations
	// Quotations dictionary
	static const TCHAR* kDictionnaireCitations = _T("D_Citations");
	// Dictionnaire Historique
	// History dictionary
	static const TCHAR* kDictionnaireHistorique = _T("D_Historique");
	// Dictionnaire Illustrations / Le Visuel intgr(MC) (module franais seulement)
	// Illustrations / Le Visuel Intgr(TM) dictionary (French module only)
	static const TCHAR* kDictionnaireIllustrations = _T("D_Illustrations");
	// Dictionnaire Wikipdia
	// Wikipedia dictionary
	static const TCHAR* kDictionnaireWikipedia = _T("D_Wikipedia");

	// Dernier guide appel
	// Last guide opened
	static const TCHAR* kGuideDernierChoisi = _T("G");
	// Guide par dfaut
	// Default guide
	static const TCHAR* kGuideParDefaut = _T("G_Defaut");
	// Guide Orthographe
	// Spelling guide
	static const TCHAR* kGuideOrthographe = _T("G_Orthographe");
	// Guide Lexique
	// Lexicon guide
	static const TCHAR* kGuideLexique = _T("G_Lexique");
	// Guide Grammaire
	// Grammar guide
	static const TCHAR* kGuideGrammaire = _T("G_Grammaire");
	// Guide Syntaxe
	// Syntax guide
	static const TCHAR* kGuideSyntaxe = _T("G_Syntaxe");
	// Guide Ponctuation
	// Punctuation guide
	static const TCHAR* kGuidePonctuation = _T("G_Ponctuation");
	// Guide Style
	// Style guide
	static const TCHAR* kGuideStyle = _T("G_Style");
	// Guide Rdaction
	// Business Writing guide
	static const TCHAR* kGuideRedaction = _T("G_Redaction");
	// Guide Typographie
	// Typography guide
	static const TCHAR* kGuideTypographie = _T("G_Typographie");
	// Guide Phontique
	// Phonetics guide
	static const TCHAR* kGuidePhonetique = _T("G_Phonetique");
	// Guide Historique
	// History guide
	static const TCHAR* kGuideHistorique = _T("G_Historique");
	// Guide Points de langue
	// Language Matters guide
	static const TCHAR* kGuidePointsDeLangue = _T("G_PointsDeLangue");

	// Langue: non spcifie (selon le contexte)
	// Language: not specified (according to context)
	static const TCHAR* kLangueSelonContexte = _T("");
	// Langue: forcer le franais
	// Language: force French
	static const TCHAR* kLangueForcerFrancais = _T("fr");
	// Langue: forcer l'anglais
	// Language: force English
	static const TCHAR* kLangueForcerAnglais = _T("en");

} // CstApiAntidote


class AntidoteApiOle : public COleDispatchDriver
{
public:
  AntidoteApiOle() : COleDispatchDriver() {}
  AntidoteApiOle(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
  AntidoteApiOle(const AntidoteApiOle& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

public:

  void ClientApiEnFermeture(LPCTSTR p_nomDeClasse)
  {
    static BYTE parms[] = VTS_BSTR ;
    InvokeHelper(0x6, DISPATCH_METHOD, VT_EMPTY, NULL, parms, p_nomDeClasse);
  }

	void ClientApiEnFermetureDispatch(LPDISPATCH p_dispatch)
  {
    static BYTE parms[] = VTS_DISPATCH ;
    InvokeHelper(0xc, DISPATCH_METHOD, VT_EMPTY, NULL, parms, p_dispatch);
  }

	void LanceOutil(LPCTSTR p_nomDeClasse, LPCTSTR p_lOutil, LPCTSTR langue, LPCTSTR versionAPI)
  {
		static BYTE parms[] = VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR;
		InvokeHelper(0xf, DISPATCH_METHOD, VT_EMPTY, NULL, parms, p_nomDeClasse, p_lOutil, langue, versionAPI);
  }

	void LanceOutilDispatch(LPDISPATCH p_dispatch, LPCTSTR p_lOutil, LPCTSTR langue, LPCTSTR versionAPI)
  {
		static BYTE parms[] = VTS_DISPATCH VTS_BSTR VTS_BSTR VTS_BSTR;
    InvokeHelper(0x10, DISPATCH_METHOD, VT_EMPTY, NULL, parms, p_dispatch, p_lOutil, langue, versionAPI);
  }
};


// ----------------------------------------------------------------------------
// AntidoteEnExecution : Retourne vrai si Antidote est en excution et est prt  recevoir des appels COM
//
// AntidoteEnExecution: Returns true if Antidote is running and ready to receive COM calls
// ----------------------------------------------------------------------------
bool AntidoteEnExecution()
{
  return (::FindWindow(kNomClasseAntidote, NULL) != NULL);
}

// ----------------------------------------------------------------------------
// LanceAntidote : Excute Antidote et attend qu'Antidote soit compltement lanc.
// Retourne vrai, si Antidote est lanc
// Retourne faux, s'il y a un problme
//
// LanceAntidote: Launches Antidote and waits until launch is complete
// Returns true upon success
// Returns false if a problem occurs
// ----------------------------------------------------------------------------
bool LancerAntidote()
{  
  bool bAntidoteEnExecution = true;

  // Vrifie si Antidote est en excution.
	//
	// Checks if Antidote is running.
	HWND hwndProcessus = ::FindWindow(kNomClasseAntidote, NULL);

  if(hwndProcessus)
  {
    ::SetForegroundWindow(hwndProcessus);
    ::BringWindowToTop(hwndProcessus);
    return true;
  }

  // Lit le dossier o est install Antidote dans les registres de Windows
	//
	// Reads Antidote's installation folder in the Windows registry
	TCHAR leDossierAntidote[MAX_PATH + 1] = _T("");
  CRegKey regKey;
  if (regKey.Open( HKEY_LOCAL_MACHINE, kCheminInstallationRegistreCle, KEY_READ) == ERROR_SUCCESS)
  {
    ULONG longMaxBuffer = MAX_PATH;
    regKey.QueryStringValue(kCheminInstallationRegistreValeur, leDossierAntidote, &longMaxBuffer);
    regKey.Close();
  }
  if (_tcslen(leDossierAntidote) > 0)
  {
    if(leDossierAntidote[_tcslen(leDossierAntidote)-1] != '\\') _tcscat_s(leDossierAntidote, _T("\\"));
    _tcscat_s(leDossierAntidote, kNomExecutableAntidote);

    SHELLEXECUTEINFO execInfo;
    execInfo.cbSize = sizeof(SHELLEXECUTEINFO);
    execInfo.fMask = NULL;
    execInfo.hwnd = NULL;
    execInfo.lpVerb = _T("open");
    execInfo.lpFile = leDossierAntidote; 
    execInfo.lpParameters = kParametreApiAntidote;
    execInfo.lpDirectory = NULL;
    execInfo.nShow = SW_SHOWNORMAL;
    execInfo.hInstApp = NULL;

	// Excute Antidote
	//
	// Launches Antidote
	BOOL res = ShellExecuteEx(&execInfo);

    if (res)
    {
			// Si l'excution d'Antidote est russie, on attend qu'Antidote soit compltement lanc.
			//
			// Upon successful launch of Antidote, waits until launch is complete.
			long i = 0;
      while (FindWindow(kNomClasseAntidote, NULL) == NULL )
      {
        Sleep(250); 
        i++;

        // Limite le temps d'attente, en cas de problme. 
				//
				// Timeout, if a problem occurs.
        if ( i > 48 ) return false;
      }
    }
    else
    {
      // En cas de problme, afficher un message  l'utilisateur pour vrifier l'installation d'Antidote.
			//
			// If a problem occurs, advise the user to check Antidote's installation.
			TCHAR szBuf[MAX_PATH + 1];
      _tcscpy_s(szBuf, _T("Incapable d'excuter "));
      _tcscat_s(szBuf, leDossierAntidote);
      _tcscat_s(szBuf, _T("\r\rVrifiez qu'Antidote est bien install."));
      MessageBox(NULL, szBuf, _T(""), MB_OK | MB_ICONEXCLAMATION);
      bAntidoteEnExecution = false;
    }
  }
  else
  {
    // Ce message indique que la cl pour le dossier d'Antidote dans les registres de Windows est vide.  
		// Le fait d'excuter Antidote rtablira la situation.
		//
		// If the registry key is empty, advise the user to manually launch Antidote. 
		MessageBox(NULL, _T("Le dossier d'Antidote est introuvable.\r\rVeuillez lancer Antidote en passant par  Dmarrer | Programmes | Antidote ."), _T(""), MB_OK | MB_ICONEXCLAMATION);
    bAntidoteEnExecution = false;
  }
  return bAntidoteEnExecution;
}

// ----------------------------------------------------------------------------
// TrouverServeurCOMDansLaROT : Trouve le serveur COM d'Antidote dans la "Running Object Table" et y attache le COleDispatchDriver (pAntidote)
//
// TrouverServeurCOMDansLaROT: Finds Antidote's COM server in the Running Object Table, then attaches the COleDispatchDriver (pAntidote)
// ----------------------------------------------------------------------------
bool TrouverServeurCOMDansLaROT(AntidoteApiOle& pAntidote)
{
  CLSID clsid;
  CT2W progId = kProgIDAntidoteApiOle;
  HRESULT err = CLSIDFromProgID(progId, &clsid);
  if( err != S_OK ) return false;
  IUnknown *pUnk = NULL;
  err = GetActiveObject(clsid, NULL, (IUnknown**)&pUnk);
  if( err != S_OK || pUnk == NULL) return false;
  IDispatch *pDisp = NULL;
  err = pUnk->QueryInterface(__uuidof(IDispatch), (LPVOID*)&pDisp);
  if( err != S_OK || pDisp == NULL) return false;
	pAntidote.AttachDispatch(pDisp);
  pUnk->Release();
  return true;
}

#undef kNomClasseAntidote
#undef kCheminInstallationRegistreValeur
#undef kNomExecutableAntidote
#undef kProgIDAntidoteApiOle
#undef kParametreApiAntidote

#endif // _ANTIDOTEAPIOLE_H_
