#include "stdafx.h"
#include "atlbase.h"
#include "Antidote APIOle VCpp MFC.h"
#include "AntidoteApiOle.h"
#include "Constantes.h"
#include "MainFrm.h"
#include "ChildFrm.h"
#include "ServeurClient.h"
#include "AntidoteApiOle.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CMainFrame						*gMainFrame;

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	ON_WM_CREATE()
	ON_COMMAND(ID_OUTILS_CORRECTEUR, OnOutilsCorrecteur)
	ON_COMMAND(ID_BUTTON_Correcteur, OnOutilsCorrecteur)
	ON_COMMAND(ID_BUTTON_Dictionnaires, OnOutilsDictionnaires)
	ON_COMMAND(ID_OUTILS_DICTIONNAIRES_DEFINITIONS, OnOutilsDictionnaires)
	ON_COMMAND(ID_OUTILS_DICTIONNAIRES_SYNONYMES, OnOutilsDictionnaires)
	ON_COMMAND(ID_OUTILS_DICTIONNAIRES_ANTONYMES, OnOutilsDictionnaires)
	ON_COMMAND(ID_OUTILS_DICTIONNAIRES_COOCCURRENCES, OnOutilsDictionnaires)
	ON_COMMAND(ID_OUTILS_DICTIONNAIRES_CHAMPSLEXICAL, OnOutilsDictionnaires)
	ON_COMMAND(ID_OUTILS_DICTIONNAIRES_CONJUGAISONS, OnOutilsDictionnaires)
	ON_COMMAND(ID_OUTILS_DICTIONNAIRES_FAMILLE, OnOutilsDictionnaires)
	ON_COMMAND(ID_OUTILS_DICTIONNAIRES_CITATIONS, OnOutilsDictionnaires)
	ON_COMMAND(ID_OUTILS_DICTIONNAIRES_HISTORIQUE, OnOutilsDictionnaires)
	ON_COMMAND(ID_OUTILS_DICTIONNAIRES_ILLUSTRATIONS, OnOutilsDictionnaires)
	ON_COMMAND(ID_OUTILS_DICTIONNAIRES_WIKIPEDIA, OnOutilsDictionnaires)
	ON_COMMAND(ID_BUTTON_Guides, OnOutilsGuides)
	ON_COMMAND(ID_OUTILS_GUIDES_ORTHOGRAPHE, OnOutilsGuides)
	ON_COMMAND(ID_OUTILS_GUIDES_LEXIQUE, OnOutilsGuides)
	ON_COMMAND(ID_OUTILS_GUIDES_GRAMMAIRE, OnOutilsGuides)
	ON_COMMAND(ID_OUTILS_GUIDES_SYNTAXE, OnOutilsGuides)
	ON_COMMAND(ID_OUTILS_GUIDES_PONCTUATION, OnOutilsGuides)
	ON_COMMAND(ID_OUTILS_GUIDES_STYLE, OnOutilsGuides)
	ON_COMMAND(ID_OUTILS_GUIDES_REDACTION, OnOutilsGuides)
	ON_COMMAND(ID_OUTILS_GUIDES_TYPOGRAPHIE, OnOutilsGuides)
	ON_COMMAND(ID_OUTILS_GUIDES_PHONETIQUE, OnOutilsGuides)
	ON_COMMAND(ID_OUTILS_GUIDES_HISTORIQUE, OnOutilsGuides)
	ON_COMMAND(ID_OUTILS_GUIDES_POINTSDELANGUE, OnOutilsGuides)
	ON_COMMAND(ID_LANGUE_DEFAUT, OnLangue)
	ON_COMMAND(ID_LANGUE_FRANCAIS, OnLangue)
	ON_COMMAND(ID_LANGUE_ANGLAIS, OnLangue)
	ON_WM_CLOSE()
END_MESSAGE_MAP()

CMainFrame::CMainFrame()
{
	gMainFrame = this;
	maLangue = "";
	// Si vous implmentez plusieurs versions de l'API d'Antidote, vous devez instancier la version la plus grande supporte  la fois par vos classes et par Antidote.
	// Exemple: Vous: (2.0 et 2.1) et Antidote: (2.1 et 2.2) --> Vous devrez passer 2.1 comme version dans LanceOutilDispatch2
	//
	// If you are implementing multiple versions of Antidote's API, instantiate the highest version that is supported by both your classes and by Antidote.
	// For example: You (2.0 et 2.1) and Antidote: (2.1 et 2.2) --> Use version 2.1 when calling LanceOutilDispatch2.
	TCHAR  versionAPIAntidote[MAX_PATH + 1] = _T("");
	CRegKey regKey;
	maVersionAPI = CString(kChaineVersionAPI);
	bool regKeyOK = false;
	if(regKey.Open(HKEY_LOCAL_MACHINE, kCheminInstallationRegistreCle, KEY_READ) == ERROR_SUCCESS)
	{
		TCHAR tmpTChar[MAX_PATH + 1] = _T("");
		ULONG longMaxBuffer = MAX_PATH;
		if(regKey.QueryStringValue(kValeurVersionAPI, tmpTChar, &longMaxBuffer) == ERROR_SUCCESS && longMaxBuffer > 0)
		{
			regKeyOK = true;
			_tcscpy(versionAPIAntidote, tmpTChar);
		}
		regKey.Close();
	}
	if(!regKeyOK)
	{
		_tcscpy(versionAPIAntidote, kChaineVersionAPI); // Valeur par dfaut / default value
	}
	double val1 = atof(CT2A(versionAPIAntidote));
	double val2 = atof(CT2A(maVersionAPI));
	double tmp = min(val1, val2);
	if(tmp > 0)
	{
		maVersionAPI.Format(_T("%.1f"), tmp);
	}
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		return -1; 
	}
	
	CImageList listeBitmap;
	CBitmap    bitmap;
	bitmap.LoadBitmap(IDB_TOOLBAR_24);
	listeBitmap.Create(16, 16, ILC_COLORDDB|ILC_MASK, 11, 1);
	listeBitmap.Add(&bitmap, RGB(255,0,255));
	m_wndToolBar.SendMessage(TB_SETIMAGELIST, 0, (LPARAM)listeBitmap.m_hImageList);
	listeBitmap.Detach();
	 bitmap.Detach();

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;

	return TRUE;
}

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG


// ----------------------------------------------------------------------------
// OnOutilsCorrecteur
// ----------------------------------------------------------------------------
void CMainFrame::OnOutilsCorrecteur()
{
	LanceCorrecteur();
}

// ----------------------------------------------------------------------------
// OnLangue
// ----------------------------------------------------------------------------
void CMainFrame::OnLangue()
{
	CMenu* menu = GetMenu();
	menu = menu->GetSubMenu(3);
	menu->CheckMenuItem(ID_LANGUE_DEFAUT, MF_UNCHECKED);
	menu->CheckMenuItem(ID_LANGUE_FRANCAIS, MF_UNCHECKED);
	menu->CheckMenuItem(ID_LANGUE_ANGLAIS, MF_UNCHECKED);
	maLangue = CstApiAntidote::kLangueSelonContexte;
	const MSG* pMsg = GetCurrentMessage();
	switch(pMsg->wParam)
	{
		case ID_LANGUE_FRANCAIS: maLangue = CstApiAntidote::kLangueForcerFrancais; break;
		case ID_LANGUE_ANGLAIS: maLangue = CstApiAntidote::kLangueForcerAnglais; break;
		default: break;
	}
	menu->CheckMenuItem(pMsg->wParam, MF_CHECKED);
}

// ----------------------------------------------------------------------------
// OnOutilsDictionnaires
// ----------------------------------------------------------------------------
void CMainFrame::OnOutilsDictionnaires()
{
	const MSG* pMsg = GetCurrentMessage();
	const TCHAR* value = CstApiAntidote::kDictionnaireDefinitions;
	switch(pMsg->wParam)
	{
		case ID_BUTTON_Dictionnaires:
		case ID_OUTILS_DICTIONNAIRES_DEFINITIONS: value = CstApiAntidote::kDictionnaireDefinitions; break;
		case ID_OUTILS_DICTIONNAIRES_SYNONYMES: value = CstApiAntidote::kDictionnaireSynonymes; break;
		case ID_OUTILS_DICTIONNAIRES_ANTONYMES: value = CstApiAntidote::kDictionnaireAntonymes; break;
		case ID_OUTILS_DICTIONNAIRES_COOCCURRENCES: value = CstApiAntidote::kDictionnaireCooccurrences; break;
		case ID_OUTILS_DICTIONNAIRES_CHAMPSLEXICAL: value = CstApiAntidote::kDictionnaireChampLexical; break;
		case ID_OUTILS_DICTIONNAIRES_CONJUGAISONS: value = CstApiAntidote::kDictionnaireConjugaison; break;
		case ID_OUTILS_DICTIONNAIRES_FAMILLE: value = CstApiAntidote::kDictionnaireFamille; break;
		case ID_OUTILS_DICTIONNAIRES_CITATIONS: value = CstApiAntidote::kDictionnaireCitations; break;
		case ID_OUTILS_DICTIONNAIRES_HISTORIQUE: value = CstApiAntidote::kDictionnaireHistorique; break;
		case ID_OUTILS_DICTIONNAIRES_ILLUSTRATIONS: value = CstApiAntidote::kDictionnaireIllustrations; break;
		case ID_OUTILS_DICTIONNAIRES_WIKIPEDIA: value = CstApiAntidote::kDictionnaireWikipedia; break;
		default: break;
	}
	LanceDictionnaire(value);
}

// ----------------------------------------------------------------------------
// OnOutilsGuides
// ----------------------------------------------------------------------------
void CMainFrame::OnOutilsGuides()
{
	const MSG* pMsg = GetCurrentMessage();
	const TCHAR* value = CstApiAntidote::kGuideOrthographe;
	switch(pMsg->wParam)
	{
		case ID_BUTTON_Guides:
		case ID_OUTILS_GUIDES_ORTHOGRAPHE: value = CstApiAntidote::kGuideOrthographe; break;
		case ID_OUTILS_GUIDES_LEXIQUE: value = CstApiAntidote::kGuideLexique; break;
		case ID_OUTILS_GUIDES_GRAMMAIRE: value = CstApiAntidote::kGuideGrammaire; break;
		case ID_OUTILS_GUIDES_SYNTAXE: value = CstApiAntidote::kGuideSyntaxe; break;
		case ID_OUTILS_GUIDES_PONCTUATION: value = CstApiAntidote::kGuidePonctuation; break;
		case ID_OUTILS_GUIDES_STYLE: value = CstApiAntidote::kGuideStyle; break;
		case ID_OUTILS_GUIDES_REDACTION: value = CstApiAntidote::kGuideRedaction; break;
		case ID_OUTILS_GUIDES_TYPOGRAPHIE: value = CstApiAntidote::kGuideTypographie; break;
		case ID_OUTILS_GUIDES_PHONETIQUE: value = CstApiAntidote::kGuidePhonetique; break;
		case ID_OUTILS_GUIDES_HISTORIQUE: value = CstApiAntidote::kGuideHistorique; break;
		case ID_OUTILS_GUIDES_POINTSDELANGUE: value = CstApiAntidote::kGuidePointsDeLangue; break;
		default: break;
	}
	LanceGuide(value);
}

// ----------------------------------------------------------------------------
// OnClose
// ----------------------------------------------------------------------------
void CMainFrame::OnClose()
{
	AvertisAntidoteAppQuitte();

	CMDIFrameWnd::OnClose();
}

// ----------------------------------------------------------------------------
// AvertisAntidoteAppQuitte : Pour avertir Antidote que l'on quitte l'application.
//
// AvertisAntidoteAppQuitte: Tell Antidote that the application is quitting.
// ----------------------------------------------------------------------------
void CMainFrame::AvertisAntidoteAppQuitte()
{
	// Seulement si Antidote est en excution.
	// Only if Antidote is running.
	if(AntidoteEnExecution())
	{
		AntidoteApiOle objAntidoteApiOle;
		if(TrouverServeurCOMDansLaROT(objAntidoteApiOle))
		{
			objAntidoteApiOle.ClientApiEnFermeture(kProgIDAntidoteAPIOleVCppMFCAntidote);
		}
	}
}

// ----------------------------------------------------------------------------
// LanceCorrecteur
// ----------------------------------------------------------------------------
void CMainFrame::LanceCorrecteur() 
{
	if (LancerAntidote())
	{
		AntidoteApiOle objAntidoteApiOle;
		if(TrouverServeurCOMDansLaROT(objAntidoteApiOle))
		{
			objAntidoteApiOle.LanceOutilDispatch(gServeurClient.GetIDispatch(true), CstApiAntidote::kOutilCorrecteur, _T(""), maVersionAPI);
		}
	}
}

// ----------------------------------------------------------------------------
// LanceDictionnaires
// ----------------------------------------------------------------------------
void CMainFrame::LanceDictionnaires()
{
	LanceDictionnaire(CstApiAntidote::kDictionnaireDefinitions);
}

// ----------------------------------------------------------------------------
// LanceDictionnaires
// ----------------------------------------------------------------------------
void CMainFrame::LanceDictionnaire(const TCHAR* const dictionnaire)
{
	if(LancerAntidote())
	{
		AntidoteApiOle objAntidoteApiOle;
		if(TrouverServeurCOMDansLaROT(objAntidoteApiOle))
		{
			objAntidoteApiOle.LanceOutilDispatch(gServeurClient.GetIDispatch(true), dictionnaire, maLangue, maVersionAPI);
		}
	}
}

// ----------------------------------------------------------------------------
// LanceGuides
// ----------------------------------------------------------------------------
void CMainFrame::LanceGuides()
{
	LanceGuide(CstApiAntidote::kGuideOrthographe);
}

// ----------------------------------------------------------------------------
// LanceGuides
// ----------------------------------------------------------------------------
void CMainFrame::LanceGuide(const TCHAR* const guide)
{
	if(LancerAntidote())
	{
		AntidoteApiOle objAntidoteApiOle;
		if(TrouverServeurCOMDansLaROT(objAntidoteApiOle))
		{
			objAntidoteApiOle.LanceOutilDispatch(gServeurClient.GetIDispatch(true), guide, maLangue, maVersionAPI);
		}
	}
}

// ----------------------------------------------------------------------------
// ActiveApplication : Active l'application pour la mettre en avant-plan.
//
// ActiveApplication: Activates the application and places it in the foreground.
// ----------------------------------------------------------------------------
void CMainFrame::ActiveApplication()
{
	SetForegroundWindow();
}

// ----------------------------------------------------------------------------
// ActiveDocument : Active le document spcifi pour le mettre devant les autres documents.
//
// ActiveDocument: Activates the specified documents and places it on top of the others.
// ----------------------------------------------------------------------------
void CMainFrame::ActiveDocument(long idDocument)
{
	::BringWindowToTop(HWND(idDocument));
}

// ----------------------------------------------------------------------------
// DonneDebutSelection : Retourne la position du dbut de la slection pour la zone de texte idZoneDeTexte du document idDocument.
//
// DonneDebutSelection: Returns the beginning of the selection in the text box 'idZoneDeTexte' in the document idDocument.
// ---------------------------------------------------------------------------- 
long CMainFrame::DonneDebutSelection(long idDocument, long idZoneDeTexte)
{
	long leDebut = 0;
	long laFin = 0;
	ActiveDocument(idDocument);

	CChildFrame* childActif = (CChildFrame*)MDIGetActive();

	if (childActif)
		childActif->DonnePosSel(idZoneDeTexte, leDebut, laFin);
	return leDebut;
}

// ----------------------------------------------------------------------------
// DonneFinSelection : Retourne la position de la fin de la slection pour la zone de texte idZoneDeTexte du document idDocument.
//
// DonneFinSelection: Returns the end of the selection in the text box 'idZoneDeTexte' in the document idDocument.
// ----------------------------------------------------------------------------
long CMainFrame::DonneFinSelection(long idDocument, long idZoneDeTexte)
{
	long leDebut = 0;
	long laFin = 0;
	ActiveDocument(idDocument);
	CChildFrame* childActif = (CChildFrame*)MDIGetActive();
	if (childActif)
		childActif->DonnePosSel(idZoneDeTexte, leDebut, laFin);
	return laFin;
}

// ----------------------------------------------------------------------------
// DonneIdDocumentCourant : Retourne lidentificateur du document courant (le document en avant-plan).
//
// DonneIdDocumentCourant: Returns the identifier of the current document (the one that is on top).
// ----------------------------------------------------------------------------
long CMainFrame::DonneIdDocumentCourant()
{
	long idDocumentCourant = 0;
	CChildFrame* childActif = (CChildFrame*)MDIGetActive();
	if (childActif)
		idDocumentCourant = childActif->DonneIdDocument();
	return idDocumentCourant;
}

// ----------------------------------------------------------------------------
// DonneIdZoneDeTexte : Retourne lidentificateur de la zone de texte correspondant  lindice indiceZoneDeTexte dans le document idDocument.
//
// DonneIdZoneDeTexte: Returns the ID of the text box corresponding to the indiceZoneDeTexte index for the idDocument document.
// ----------------------------------------------------------------------------
long CMainFrame::DonneIdZoneDeTexte(long idDocument, long indiceZoneDeTexte)
{
	long idZoneDeTexteCourante = 0;
	ActiveDocument(idDocument);
	CChildFrame* childActif = (CChildFrame*)MDIGetActive();

	if (childActif)
		idZoneDeTexteCourante = childActif->DonneIdZoneDeTexte(indiceZoneDeTexte);
	return idZoneDeTexteCourante;
}

// ----------------------------------------------------------------------------
// DonneIdZoneDeTexteCourante : Retourne lidentificateur de la zone de texte courante (la zone de texte qui contient le curseur).
//
// DonneIdZoneDeTexteCourante: Returns the ID of the current text box (where the text cursor is currently placed).
// ----------------------------------------------------------------------------
long CMainFrame::DonneIdZoneDeTexteCourante(long idDocument)
{
	long idZoneDeTexteCourante = 0;
	ActiveDocument(idDocument);
	CChildFrame* childActif = (CChildFrame*)MDIGetActive();
	if (childActif)
		idZoneDeTexteCourante = childActif->DonneIdZoneDeTexteCourante();
	return idZoneDeTexteCourante;
}

// ----------------------------------------------------------------------------
// DonneIntervalle : Retourne le texte de la zone de texte idZoneDeTexte, de la position leDebut jusqu la position laFin, dans le document idDocument.
//
// DonneIntervalle: Returns the contents of the text box idZoneDeTexte, from "leDebut" to "laFin", in the idDocument document.
// ----------------------------------------------------------------------------
void CMainFrame::DonneIntervalle(long idDocument, long idZoneDeTexte, long leDebut, long laFin, CString &strIntervalle)
{
	strIntervalle = "";
	ActiveDocument(idDocument);
	
	CChildFrame* childActif = (CChildFrame*)MDIGetActive();
	if (childActif)
		childActif->DonneIntervalle(idZoneDeTexte, leDebut, laFin, strIntervalle);
}

// ----------------------------------------------------------------------------
// DonneLongueurZoneDeTexte : Retourne la longueur de la zone de texte idZoneDeTexte dans le document idDocument.
//
// DonneLongueurZoneDeTexte: Returns the number of characters in the text box indicated by 'idZoneDeTexte' in the idDocument document.
// ----------------------------------------------------------------------------
long CMainFrame::DonneLongueurZoneDeTexte(long idDocument, long idZoneDeTexte)
{
	ActiveDocument(idDocument);
	long lgZoneDeTexte = 0;
	CChildFrame* childActif = (CChildFrame*)MDIGetActive();
	if (childActif)
		lgZoneDeTexte = childActif->DonneLongueurZoneDeTexte(idZoneDeTexte);
	return lgZoneDeTexte;
}

// ----------------------------------------------------------------------------
// DonneNbZonesDeTexte : Retourne le nombre de zones de texte dans le document spcifi.
//
// DonneNbZonesDeTexte: Returns the number of text boxes in the idDocument document.
// ----------------------------------------------------------------------------
long CMainFrame::DonneNbZonesDeTexte(long idDocument)
{
	ActiveDocument(idDocument);

	long nbZonesDeTexte = 0;
	CChildFrame* childActif = (CChildFrame*)MDIGetActive();
	if (childActif)
		nbZonesDeTexte = childActif->DonneNbZonesDeTexte();
	return nbZonesDeTexte;
}

// ----------------------------------------------------------------------------
// DonnePolice :  Mthode obsolte prsente pour rtrocompatibilit uniquement. Retourner une chaine vide.
//
// DonnePolice:  Obsolete method present only for reasons of backward compatibility. Returns an empty string.
// ----------------------------------------------------------------------------
void CMainFrame::DonnePolice(long idDocument, long idZoneDeTexte, CString &strNomPolice)
{
	ActiveDocument(idDocument);

	CChildFrame* childActif = (CChildFrame*)MDIGetActive();
	if (childActif)
		childActif->DonnePolice(idZoneDeTexte, strNomPolice);
	else
		strNomPolice = "";
}

// ----------------------------------------------------------------------------
// DonneTitreDocCourant : Retourne le titre du document courant.
//
// DonneTitreDocCourant: Returns the name of the current document.
// ----------------------------------------------------------------------------
void CMainFrame::DonneTitreDocCourant(CString &strTitreDoc)
{
	CMDIChildWnd* childActif = MDIGetActive();
	if (childActif)
		childActif->GetWindowText(strTitreDoc);
	else
		strTitreDoc = "";
}

// ----------------------------------------------------------------------------
// RemplaceIntervalle : Remplace le texte  l'endroit spcifi
//
// RemplaceIntervalle: Replaces the text in the specified location.
// ----------------------------------------------------------------------------
void CMainFrame::RemplaceIntervalle(long idDocument, long idZoneDeTexte, long leDebut, long laFin, BSTR* laChaine)
{
	ActiveDocument(idDocument);
	
	CChildFrame* childActif = (CChildFrame*)MDIGetActive();
	if (childActif)
		childActif->RemplaceIntervalle(idZoneDeTexte, leDebut, laFin, laChaine);
}

// ----------------------------------------------------------------------------
// SelectionneIntervalle : Slectionne le texte  l'endroit spcifi
//
// SelectionneIntervalle: Selects the text in the specified location.
// ----------------------------------------------------------------------------
void CMainFrame::SelectionneIntervalle(long idDocument, long idZoneDeTexte, long leDebut, long laFin)
{
	ActiveDocument(idDocument);

	CChildFrame* childActif = (CChildFrame*)MDIGetActive();
	if (childActif)
		childActif->SelectionneIntervalle(idZoneDeTexte, leDebut, laFin);
}
