﻿using Antidote_APIOle_VCSharp_dotNet;
using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.Runtime.InteropServices;
using System.Threading;
using System.Windows.Forms;

namespace Antidote_APIOle_VCSharp_dotNet
{
	[ComVisible(false)]
	public partial class Assoc
	{
		public string texte;
		public string tag;

		public Assoc(string texte, string tag) { this.texte = texte; this.tag = tag; }
	}

	[ComVisible(false)]
	sealed public class ConstantesOutils
	{
		// Correcteur
		// Corrector
		public const string kOutilCorrecteur = "C";

		// Dernier dictionnaire appelé
		// Last dictionary opened
		public const string kDictionnaireDernierChoisi = "D";
		// Dictionnaire par défaut
		// Default dictionary
		public const string kDictionnaireDefaut = "D_Defaut";
		// Dictionnaire Définitions
		// Definitions dictionary
		public const string kDictionnaireDefinitions = "D_Definitions";
		// Dictionnaire Synonymes
		// Synonyms dictionary
		public const string kDictionnaireSynonymes = "D_Synonymes";
		// Dictionnaire Antonymes (module français seulement)
		// Antonyms dictionary (French module only)
		public const string kDictionnaireAntonymes = "D_Antonymes";
		// Dictionnaire Cooccurrences
		// Combinations dictionary
		public const string kDictionnaireCooccurrences = "D_Cooccurrences";
		// Dictionnaire Champ lexical
		// Semantic Field dictionary
		public const string kDictionnaireChampLexical = "D_ChampLexical";
		// Dictionnaire Conjugaison
		// Conjugation dictionary
		public const string kDictionnaireConjugaison = "D_Conjugaison";
		// Dictionnaire Famille
		// Family dictionary
		public const string kDictionnaireFamille = "D_Famille";
		// Dictionnaire Citations
		// Quotations dictionary
		public const string kDictionnaireCitations = "D_Citations";
		// Dictionnaire Historique
		// History dictionary
		public const string kDictionnaireHistorique = "D_Historique";
		// Dictionnaire Illustrations / Le Visuel intégré(MC) (module français seulement)
		// Illustrations / Le Visuel Intégré(TM) dictionary (French module only)
		public const string kDictionnaireIllustrations = "D_Illustrations";
		// Dictionnaire Wikipédia
		// Wikipedia dictionary
		public const string kDictionnaireWikipedia = "D_Wikipedia";

		// Dernier guide appelé
		// Last guide opened
		public const string kGuideDernierChoisi = "G";
		// Guide par défaut
		// Default guide
		public const string kGuideParDefaut = "G_Defaut";
		// Guide Orthographe
		// Spelling guide
		public const string kGuideOrthographe = "G_Orthographe";
		// Guide Lexique
		// Lexicon guide
		public const string kGuideLexique = "G_Lexique";
		// Guide Grammaire
		// Grammar guide
		public const string kGuideGrammaire = "G_Grammaire";
		// Guide Syntaxe
		// Syntax guide
		public const string kGuideSyntaxe = "G_Syntaxe";
		// Guide Ponctuation
		// Punctuation guide
		public const string kGuidePonctuation = "G_Ponctuation";
		// Guide Style
		// Style guide
		public const string kGuideStyle = "G_Style";
		// Guide Rédaction
		// Business Writing guide
		public const string kGuideRedaction = "G_Redaction";
		// Guide Typographie
		// Typography guide
		public const string kGuideTypographie = "G_Typographie";
		// Guide Phonétique
		// Phonetics guide
		public const string kGuidePhonetique = "G_Phonetique";
		// Guide Historique
		// History guide
		public const string kGuideHistorique = "G_Historique";
		// Guide Points de langue
		// Language Matters guide
		public const string kGuidePointsDeLangue = "G_PointsDeLangue";

		// Langue: non spécifiée (selon le contexte)
		// Language: not specified (according to context)
		public const string kLangueSelonContexte = "";
		// Langue: forcer le français
		// Language: force French
		public const string kLangueForcerFrancais = "fr";
		// Langue: forcer l'anglais
		// Language: force English
		public const string kLangueForcerAnglais = "en";


		public static List<Assoc> listeDictionnaires = new List<Assoc>
		{
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineDefinition"),kDictionnaireDefinitions),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineSynonymes"),kDictionnaireSynonymes),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineAntonymes"),kDictionnaireAntonymes),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineCooccurrences"),kDictionnaireCooccurrences),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineChampsLexical"),kDictionnaireChampLexical),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineConjugaison"),kDictionnaireConjugaison),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineFamille"),kDictionnaireFamille),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineCitation"),kDictionnaireCitations),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineHistorique"),kDictionnaireHistorique),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineIllustrations"),kDictionnaireIllustrations),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineWikipedia"),kDictionnaireWikipedia),
		};

		public static List<Assoc> listeGuides = new List<Assoc>
		{
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineOrthographe"),kGuideOrthographe),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineLexique"),kGuideLexique),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineGrammaire"),kGuideGrammaire),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineSyntaxe"),kGuideSyntaxe),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChainePonctuation"),kGuidePonctuation),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineStyle"),kGuideStyle),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineRedaction"),kGuideRedaction),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineTypographie"),kGuideTypographie),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChainePhonetique"),kGuidePhonetique),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineHistorique"),kGuideHistorique),
			new Assoc(Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChainePointDeLangue"),kGuidePointsDeLangue),
			};
	}


	sealed public class ServeurAntidote
	{
		[DllImport("user32.dll", CharSet = CharSet.Auto)]
		private static extern IntPtr FindWindow(string strClassName, string strWindowName);
		[DllImport("user32.dll", CharSet = CharSet.Auto)]
		private static extern void SetForegroundWindow(IntPtr hwnd);
		[DllImport("user32.dll", CharSet = CharSet.Auto)]
		private static extern void BringWindowToTop(IntPtr hwnd);

		class Constantes
		{
			public const string kChaineVersionAPI = "2.0";
			public const string kCheminInstallationRegistreCle = "SOFTWARE\\Druide informatique inc.\\Antidote";
			public const string kCheminInstallationRegistreValeur = "DossierAntidote";
			public const string kValeurVersionAPI = "VersionAPI";
			public const string kNomClasseAntidote = "AntQ";
			public const string kNomExecutableAntidote = "Antidote.exe";
			public const string kParametreApiAntidote = "-activex";
			public const string kProgIDAntidoteApiOle = "Antidote.ApiOle";
		}

		public static void AppelleAntidote(string str, string langue)
		{
			Thread thread = new Thread(new ParameterizedThreadStart(AppelleAntidote));
			string parametres = str + ";" + langue;
			thread.Start(parametres);
		}

		public static void InformeAntidoteQueJeMeFerme()
		{
			IntPtr hwndAntidote = ServeurAntidote.AntidoteEnExecution();
			if (hwndAntidote.ToInt32() != 0)
			{
				Interop.AntidoteLib.ApiOle api = DonneServeurAntidote();
				if (api != null)
					api.ClientApiEnFermetureDispatch(ServeurClient.Instance());
			}
		}

		private static void AppelleAntidote(object obj)
		{
			Interop.AntidoteLib.ApiOle api = DonneServeurAntidote();
			string langue = "";
			string[] table = ((string)obj).Split(';');
			string outil = table[0];
			if (table.Length > 1)
			{
				langue = table[1];
			}
			if (api != null)
			{
				// Si vous implémentez plusieurs versions de l'API d'Antidote, vous devez instancier la version la plus grande supportée à la fois par vos classes et par Antidote.
				// Exemple: Vous: (2.0 et 2.1) et Antidote: (2.1 et 2.2) --> Vous devrez passer 2.1 comme version dans LanceOutilDispatch2
				//
				// If you are implementing multiple versions of Antidote's API, instantiate the highest version that is supported by both your classes and by Antidote.
				// For example: You (2.0 et 2.1) and Antidote: (2.1 et 2.2) --> Use version 2.1 when calling LanceOutilDispatch2.
				RegistryKey pRegKey = Microsoft.Win32.Registry.LocalMachine;
				CultureInfo enus = new CultureInfo("en-US");
				pRegKey = pRegKey.OpenSubKey(Constantes.kCheminInstallationRegistreCle);
				string versionString = pRegKey.GetValue(Constantes.kValeurVersionAPI, Constantes.kChaineVersionAPI).ToString();
				double versionAPIAntidote = double.Parse(versionString, enus);
				double maVersionAPI = double.Parse(Constantes.kChaineVersionAPI, enus);
				string versionAPI = Math.Min(versionAPIAntidote, maVersionAPI).ToString("N1",enus);
				api.LanceOutilDispatch2(ServeurClient.Instance(), outil, langue, versionAPI);
			}
		}

		private static Interop.AntidoteLib.ApiOle DonneServeurAntidote()
		{      
			IntPtr hwndAntidote = AntidoteEnExecution();
			bool dejaEnExecution = hwndAntidote.ToInt32() != 0;
			if (dejaEnExecution)
			{
				SetForegroundWindow(hwndAntidote);
				BringWindowToTop(hwndAntidote);
			}
			else
			{
				if (!LanceAntidote())
					return null;
			}
			// Trouve le serveur COM d'Antidote dans la "Running Object Table"
			//
			// Finds Antidote's COM server in the Running Object Table
			return (Interop.AntidoteLib.ApiOle)System.Runtime.InteropServices.Marshal.GetActiveObject(Constantes.kProgIDAntidoteApiOle);
		}

		private static IntPtr AntidoteEnExecution()
		{
			return FindWindow(Constantes.kNomClasseAntidote, null);
		}

		// ----------------------------------------------------------------------------
		// LanceAntidote : Exécute Antidote et attend qu'Antidote soit complètement lancé.
		// Retourne vrai, si Antidote est lancé
		// Retourne faux, s'il y a un problème
		//
		// LanceAntidote: Launches Antidote and waits until launch is complete
		// Returns true upon success
		// Returns false if a problem occurs
		// ----------------------------------------------------------------------------
		private static bool  LanceAntidote()
		{
			RegistryKey pRegKey = Microsoft.Win32.Registry.LocalMachine;
			pRegKey = pRegKey.OpenSubKey(Constantes.kCheminInstallationRegistreCle);
			object obj = pRegKey.GetValue(Constantes.kCheminInstallationRegistreValeur, "Invalide");
			if (obj.ToString() == "Invalide")
			{
				// Ce message indique que la clé pour le dossier d'Antidote dans les registres de Windows est vide.  
				// Le fait d'exécuter Antidote rétablira la situation.
				//
				// If the registry key is empty, advise the user to manually launch Antidote.
				MessageBox.Show(null, Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineMsgErreur1"), "", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				return false;
			}
			string cheminAntidote = obj.ToString();
			if (!cheminAntidote.EndsWith("\\")) cheminAntidote += "\\";
			cheminAntidote += Constantes.kNomExecutableAntidote;
			System.Diagnostics.Process.Start(cheminAntidote, Constantes.kParametreApiAntidote);

			// On attend qu'Antidote soit complètement lancé.
			//
			// Waits until launch is complete.
			long i = 0;
			bool enExecution = AntidoteEnExecution().ToInt32() != 0;
			while (!enExecution)
			{
				System.Threading.Thread.Sleep(250);
				i++;
				// Limite le temps d'attente, en cas de problème. 
				//
				// Timeout, if a problem occurs.
				if (i > 48)
				{
					MessageBox.Show(null, Antidote_APIOle_VCSharp_dotNet.Program.DonneChaine("kChaineMsgErreur2"), "", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
					return false;
				}
				enExecution = AntidoteEnExecution().ToInt32() != 0;
			}

			return true;
		}
}
}
