﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Antidote_APIOle_VCSharp_dotNet
{
	public partial class ChildMDIfrm : Form
	{
		List<TextBox> mesTextBox;
		int monId;

		public ChildMDIfrm(int id)
		{
			InitializeComponent();
			monId = id;
			mesTextBox = new List<TextBox>();
			mesTextBox.Add(this.bteTexteDestinataire);
			mesTextBox.Add(this.bteTexteDestination);
			mesTextBox.Add(this.bteTexteSujet);
			mesTextBox.Add(this.btePrincipale);
		}

		public long DonneDebutSelection(long idZone)
		{
			TextBox t = null;
			DonneBoiteTexte(idZone,ref t);
			if (t == null)
				return -1;
			return t.SelectionStart;
		}

		public long DonneFinSelection(long idZone)
		{
			TextBox t = null;
			DonneBoiteTexte(idZone, ref t);
			if (t == null)
				return -1;
			return t.SelectionStart + t.SelectionLength;
		}

		public TextBox DonneZoneActive()
		{
			long l = DonneIdZoneActive();
			TextBox t = null;
			if(l != -1)
				DonneBoiteTexte(l,ref t);
			return t;
		}

		public long DonneIdZoneActive()
		{
			TextBox t = null;
			Control c = this.ActiveControl;
			if (c == this.btePrincipale)
				t = btePrincipale;
			else if (c == this.bteTexteDestinataire)
				t = bteTexteDestinataire;
			else if (c == this.bteTexteSujet)
				t = bteTexteSujet;
			else if (c == this.bteTexteDestination)
				t = bteTexteDestination;
			if (t != null)
			{
				return long.Parse(t.Tag.ToString());
			}
			return -1;
		}

		// L'indice commence à 1.
		// The index begins at 1.
		public long DonneIdZoneDeTexte(int indiceDuDebutDuDocument) 
		{
			if(indiceDuDebutDuDocument - 1 < mesTextBox.Count)
				return long.Parse(mesTextBox[indiceDuDebutDuDocument - 1].Tag.ToString());
			return -1;
		}

		public string DonneIntervalle(long idZone, int leDebut, int laFin)
		{
			TextBox t = null;
			DonneBoiteTexte(idZone, ref t);
			if (t == null)
				return "";
			return t.Text.Substring(leDebut, laFin - leDebut);
		}

		public long DonneLongueurZoneDeTexte(long idZone)
		{
			TextBox t = null;
			DonneBoiteTexte(idZone, ref t);
			if (t == null)
				return -1;
			return t.Text.Length;
		}

		public int DonneNbBoitesTexte()
		{
			return mesTextBox.Count;
		}

		public void RemplaceIntervalle(long idZone, int leDebut, int laFin, ref string laChaine)
		{
			TextBox t = null;
			DonneBoiteTexte(idZone, ref t);
			if (t == null)
				return;
			SelectionneIntervalle(t, leDebut, laFin);
			t.SelectedText = laChaine;
		}

		public void SelectionneIntervalle(long idZone, int leDebut, int laFin)
		{
			TextBox t = null;
			DonneBoiteTexte(idZone, ref t);
			if (t == null)
				return;
			SelectionneIntervalle(t, leDebut, laFin);
		}

		private void SelectionneIntervalle(TextBox t, int leDebut, int laFin)
		{
				this.ActiveControl = t;
				t.Focus();
				t.Select(leDebut, laFin - leDebut);
		}

		private void DonneBoiteTexte(long id, ref TextBox bte)
		{
			bte = null;
			if (id == -1)
				return;
			else
			{
				List<TextBox>.Enumerator it = mesTextBox.GetEnumerator();
				while (it.MoveNext())
				{
					if (it.Current == null)
						break;
					if (long.Parse(it.Current.Tag.ToString()) == id)
					{
						bte = it.Current;
						break;
					}
				}
			}
		}
	}
}
